// Lader fr Windows-BMP-Dateien: Dieses Programm zeigt am Bildschirm
// beliebige .BMP-Dateien dar, wobei, sobald das Bild mehr Farben als
// der Videomodus aufweist, automatisch gerastert (Dither-Technik) wird
// 'FallBack'-Technik analog der QuickBASIC-Version: Reicht die Farbpalette
// nicht aus, so werden im RGB-Wrfel die Farbstufen reduziert => Wieder-
// holung des Bildladevorgangs

// Ferner Bildspeicherungsoption : Dies ermglicht es, diesen Anzeiger als
// einfachste Farbreduktions/erweiterungssoftware  la "HiJaak Pro" zu
// "missbrauchen"

// (c) 1996 by Andreas Meile, HTL Brugg-Windisch

#include <stdio.h>
#include <conio.h>
#include <grx.h>
#include "eing_rou.h" // Paket mit Eingaberoutinen
#include "bmp_spei.h" // Paket mit BMP-Speicherroutine

const int max_anz_stufen = 20; // Grsste Stufenzahl beim Start

int treiber_konst = GR_width_height_color_graphics, // Hardware-Konstante fr
    // Grafikaktivierung; falls mit lterem Treiber ohne Explizit-Modusangabe
    // gearbeitet wird, muss vom Benutzer ein anderer Wert eingegeben werden

    x_aufl = 320, // horizontale Grafikauflsung (mit Vorgabewerte)
    y_aufl = 200, // vertikale Grafikauflsung
    a_far = 256,  // Anzahl Farben
    no_fall_back, // FallBack-Variable, falls die Palettenstifte ausgehen
                  // (Beim 32768-Videomodus tritt dieser Effekt nicht auf)
    anz_stufen,   // Anzahl Stufen
    anz_st_m1,    // Anzahl Stufen - 1
    far_umr,      // Farbumrechungsfaktor
    anz_pal_far,  // Anzahl bereits benutzte Palettenfarben
    rgb_verarb,   // Verarbeitungsmodus: 0 = direkt, 1 = RGB/Dither => Fallback

    pal_fa_nr[max_anz_stufen][max_anz_stufen][max_anz_stufen], // Tabelle mit
                  // Farb-Querverweisen

    ht[128],      // Hilfstabelle fr Dithering

    // Variablen mit Bilddateidaten; im Zusammenhand mit der Schlussstatistik
    // aus dem Modul "lade_bild" ausgelagert

    x_bild,       // horizontale Auflsung des Bildes
    y_bild,       // dito vertikal
    a_fa_bild,    // Anzahl Farben des Bildes
    x_darst,      // Darstellbreite
    y_darst,      // Darstellhhe, falls das Bild nicht Platz hat
    komp_typ,     // Art der Bildkompression
    x_dpm,        // Punktdichte horizontal (Pixel/Meter)
    y_dpm;        // Punktdichte vertikal (Pixel/Meter)

    short anz_bitpl,       // Anzahl Bitebenen
          anz_bit_pro_pix, // Anz. Bit pro Pixel

// Fr das optionale Abspeichern vorgesehene Variablen

    erfolg;       // Flag, ob Speicherung erfolgreich
char bild_abspeich_name[70];  // Dateiname fr optionales Neuabspeichern

// Alle wichtigeren Kompressionsarten
const int NO_COMPRESSION = 0;  // Kennung fr unkomprimiert
const int RLE8_COMPRESSED = 1; // Kennung fr RLE8-komprimiert
const int RLE4_COMPRESSED = 2; // Kennung fr RLE4-komprimiert

// Bruchkrzer : wird im Zusammenhang mit der Skalierung verwendet, um
// grosse, berlaufgefhrdete Werte vermeiden zu knnen

int kuerze(int &a, int &b) {  // C++-Syntax
  register int a1, b1, c;
  if(b > a) {
    a1 = b;
    b1 = a;
  } else {
    a1 = a;
    b1 = b;
  }
  c = a1 % b1;
  while(c) {
    a1 = b1;
    b1 = c;
    c = a1 % b1;
  }
  a = a / b1;
  b = b / b1;
  return b1; // Krzungsfaktor zurckliefern
}

// Anhngen von .BMP bei einem Dateinamenstring
void haenge_bmp_an(char *dat_name) {
  register int i=-1;
  while(dat_name[++i]); // End-Nullbyte suchen
  dat_name[i++] = '.';
  dat_name[i++] = 'B';
  dat_name[i++] = 'M';
  dat_name[i++] = 'P';
  dat_name[i] = '\0';
}

// Hilfstabelle fr Dithering aufbauen
void baue_dither_tabelle_auf() {
  for(int i=0; i<128; i++)
    ht[i] = 0;

  int k=1;
  for(i=64; i; i = i >> 1) {
    for(int j=0; j<128; j++) {
      if(j & i)
        ht[j] = ht[j] | k;
    }
    k=k << 2;
  }
}

void zeichne_punkt (int x, int y, unsigned char r, unsigned char g,
unsigned char b, int mit_dither = 1) {
  // Punkt wie in einem Echfarb-Grafikmodus hier mit Dither-Technik setzen
  if(a_far == 0x10000000)  // Echtfarbmodus
    GrPlot(x, y, r << 16 | g << 8 | b);
  else {
    int r2, g2, b2;
    if(mit_dither) {
      int r1 = (r * far_umr) / 255,
          g1 = (g * far_umr) / 255,
          b1 = (b * far_umr) / 255,
          schwelle = (ht[(x + y)& 127] << 1) + ht[x & 127];
      r2 = (r1 >> 14) + ((r1 & 0x00003fff) > schwelle);
      g2 = (g1 >> 14) + ((g1 & 0x00003fff) > schwelle);
      b2 = (b1 >> 14) + ((b1 & 0x00003fff) > schwelle);
    } else {
      r2 = (r * anz_stufen) >> 8;
      g2 = (g * anz_stufen) >> 8;
      b2 = (b * anz_stufen) >> 8;
    }
    if(a_far == 32768) // 32K-Farbmodus
      GrPlot(x, y, r2 << 10 | g2 << 5 | b2);
    else { // Sonstige Videomodi mit 16 bzw. 256 Farben und Palettensystem
      register int pal_far = pal_fa_nr[r2][g2][b2];
      if(pal_far == -1) { // Weitere Farbe ntig
        if(anz_pal_far == a_far)
          no_fall_back = 0; // FallBack ntig
        else {
          pal_far = anz_pal_far; // Neue Palettenfarbe anlegen
          anz_pal_far++;
          pal_fa_nr[r2][g2][b2] = pal_far;
          GrSetColor(pal_far, (255 * r2) / anz_st_m1,
                              (255 * g2) / anz_st_m1,
                              (255 * b2) / anz_st_m1);
        }
      }
      if(no_fall_back)
        GrPlot(x, y, pal_far);
    }
  }
}

// Bilderlader: nur grafischer Teil
int lade_bild(const char *b_name, // Bildname (mit ".BMP"!)
              int einpass = 0,    // Flag, ob Einpassen (2), verzerrtes
                                  // Einpassen (1) oder 1:1 (0)
              int dither = 1,     // Flag, ob mit Dither (1) oder Vollton (0)
              int start_anz_stufen = max_anz_stufen) { // Anzahl Farbstufen

  // Tabelle mit smtlichen gltigen Bildfarbarten
  const int guelt_anz_bitplanes[6] = {1, 4, 4, 8, 8, 24};
  const int guelt_kompression[6] = {NO_COMPRESSION, NO_COMPRESSION,
  RLE4_COMPRESSED, NO_COMPRESSION, RLE8_COMPRESSED, NO_COMPRESSION};

  FILE *d_handle; // Datei-Handle whrend dem Einlesen

  long seek_basis,   // Basis-SEEK-Offset der Bitmapdaten
       seek_start,   // Effektiver Start fr Bildschirmzeile 0, da BMP-Bilder
                     // von unten nach Oben gespeichert sind
       seek_offs,    // SEEK-Differenz zwischen zwei Pixelzeilen
       bitm_info_gr; // Grsse des BITMAPINFOHEADERs


  char B_kenn, M_kenn; // fr .BMP-Kennung "BM"

  unsigned char rgb_palette[256][3]; // Platz fr RGB-Palette des Bildes

  d_handle = fopen(b_name, "rb");
  if(d_handle == 0)
    return 4; // 4 = Datei konnte nicht geffnet werden
  // .BMP-typische Kennung "BM" einlesen
  fread(&B_kenn, 1, sizeof(B_kenn), d_handle);
  fread(&M_kenn, 1, sizeof(M_kenn), d_handle);
  // .BMP-Kennung berprfen
  if(B_kenn != 'B' || M_kenn != 'M') {
    fclose(d_handle);
    return 3; // 3 = Keine gltige .BMP-Datei
  }
  fseek(d_handle, 0x0a, SEEK_SET);
  fread(&seek_basis, 1, sizeof(seek_basis), d_handle);
  // Ab hier beginnt der BITMAPINFOHEADER
  fread(&bitm_info_gr, 1, sizeof(bitm_info_gr), d_handle);
  fread(&x_bild, 1, sizeof(x_bild), d_handle);
  fread(&y_bild, 1, sizeof(y_bild), d_handle);
  fread(&anz_bitpl, 1, sizeof(anz_bitpl), d_handle);
  fread(&anz_bit_pro_pix, 1, sizeof(anz_bit_pro_pix), d_handle);
  fread(&komp_typ, 1, sizeof(komp_typ), d_handle);
  fseek(d_handle, 0x0e + 0x18, SEEK_SET);
  fread(&x_dpm, 1, sizeof(x_dpm), d_handle);
  fread(&y_dpm, 1, sizeof(y_dpm), d_handle);

  // Bildtyp berprfen
  {
    register int i=0;
    while(i < 6 && (anz_bit_pro_pix != guelt_anz_bitplanes[i] || 
    komp_typ != guelt_kompression[i]))
      i++; // bei Erreichen von i=6 liegt irgend ein ungltiges Format vor
    if(anz_bitpl != 1 || i == 6) {
      fclose(d_handle);
      return 2; // 2 = .BMP-Datei mglicherweise irgend einer zuknftigen
    }           // Windowsversion vorliegend
  }

  // Prfung, ob berhaupt untersttzt
  if(komp_typ != NO_COMPRESSION) {
    fclose(d_handle);
    return 1; // 1 = Nicht untersttzter .BMP-Dateityp (im Moment nur
  }           // unkomprimierte Dateien zulssig)

  // Parameter vorbereiten
  seek_offs = (x_bild * anz_bit_pro_pix + 31 & -32) >> 3;

  // alter Videomodus sichern
  int alter_videomodus = GrCurrentMode();

  // Vom Benutzer gewhlter Videomodus setzen (inkl. Hardwarekonstante)
  GrSetMode(treiber_konst, x_aufl, y_aufl, a_far);
  GrClearScreen(0);
  // Effektive Werte auslesen
  x_aufl = GrScreenX();
  y_aufl = GrScreenY();
  a_far = GrNumColors();

  // Verhltnis der Bildrhre
  const int x_b_roehre = 4;
  const int y_b_roehre = 3;

  // Vorgabewerte gelten fr verzerrte Darstellung
  int x_mult_fakt = x_bild, // Faktor fr x-Skalierung (Zhler)
      x_div_fakt  = x_aufl, // Faktor fr y-Skalierung (Nenner)
      y_mult_fakt = y_bild, // Faktor fr x-Skalierung (Zhler)
      y_div_fakt  = y_aufl, // Faktor fr y-Skalierung (Nenner)
      x_verh = x_dpm + (!x_dpm), // Pixelbreiten/Hhenverhltnis 
      y_verh = y_dpm + (!y_dpm); // mit Nullwert-Schutz 

  kuerze(x_mult_fakt, x_div_fakt); // Brche krzen
  kuerze(y_mult_fakt, y_div_fakt); // Brche krzen
  kuerze(x_verh, y_verh); // krzen

  if(einpass) { // Ganzes Bild in Bildschirm einpassen (Skalierung)
    seek_start = seek_basis + (y_bild - 1) * seek_offs;
    if(einpass == 2) {   // Proportionen mssen beibehalten werden
      if(y_b_roehre * x_bild * y_verh > x_b_roehre * y_bild * x_verh) {
        y_mult_fakt = x_bild * y_b_roehre * y_verh;
        y_div_fakt = y_aufl * x_b_roehre * x_verh;
        kuerze(y_mult_fakt, y_div_fakt);
      } else {
        x_mult_fakt = y_bild * x_b_roehre * x_verh;
        x_div_fakt = x_aufl * y_b_roehre * y_verh;
        kuerze(x_mult_fakt, x_div_fakt);
      }
    }
  } else {      // Darstellung pixelmssig 1:1
    if(x_bild > x_aufl)
      x_darst = x_aufl;
    else
      x_darst = x_bild;
    if(y_bild > y_aufl)
      y_darst = y_aufl;
    else
      y_darst = y_bild;
    seek_start = seek_basis + (y_darst - 1) * seek_offs;
  }
  a_fa_bild = 1 << anz_bit_pro_pix; // Anzahl Farben in der Bilddatei

  // Verarbeitungsmodus bezglich Farben zum Bildschirm

  rgb_verarb = a_far < a_fa_bild || a_far >= 32768;
  int konvert_ja = a_fa_bild <= 256;

  if(konvert_ja) { // Farbpalette noch vorbereiten
    long rgb_seek_pos = 0xe + bitm_info_gr; // Basis fr RGB-Farben
    for(int i=0; i < a_fa_bild; i++) {
      fseek(d_handle, rgb_seek_pos, SEEK_SET);
      fread(&rgb_palette[i][0], 1, sizeof(rgb_palette[i]), d_handle);
      if(!rgb_verarb) // Farbe direkt setzen, da gengend Farben
        GrSetColor(i, rgb_palette[i][2], rgb_palette[i][1],
        rgb_palette[i][0]);
      rgb_seek_pos += 4; // Zur nchsten Farbe bergehen
    }
  }

  if(a_far == 32768)
    anz_stufen = 32;  // Speziell fr 32K-Echtfarbmodus
  else
    anz_stufen = start_anz_stufen;

  do {
    if(a_far < 32768) { // Videomodus mit Palettensystem
      // Alle Farbpalettenregister freigeben
      for(int r = 0; r < anz_stufen; r++) {
        for(int g = 0; g < anz_stufen; g++) {
          for(int b = 0; b < anz_stufen; b++) {
            pal_fa_nr[r][g][b] = -1;
          }
        }
      }
      anz_pal_far = 0;
    }

    anz_st_m1 = anz_stufen - 1;
    far_umr = anz_st_m1 << 14;  // Fertiger Hilfumrechnungsfaktor
    no_fall_back = 1;
    
    // Bild darstellen (versuchen)
    unsigned char rgb_trip[3], // Platz fr RGB-Tripel
                  f_wert,      // Pixelwert (nur bei <= 256 Farben)
                  dat_byte;    // Datenbyte (nur bei <= 16 Farben)

    if(einpass) {
      register long alt_seek = -1;
      for(int y=0; no_fall_back && y < y_aufl + 10; y++) {
        register int y_pos = (y * y_mult_fakt) / y_div_fakt,
                     alt_x = -20;
        if(y_pos < y_bild) {
          register long seek_zeil_basis = seek_start - seek_offs * y_pos,
                        alt_seek_p = -200;
          for(int x=0; no_fall_back && x < x_aufl + 10; x++) {
            register int x_pos = (x * x_mult_fakt) / x_div_fakt;
            if(x_pos < x_bild) {
              if(x_pos != alt_x) {
                // Fallmssig unterscheiden anhand des Bildtyps
                switch(anz_bit_pro_pix) {
                  case 24 : {
                    if(x_pos > ++alt_x) // berspringen von Pixeln
                      fseek(d_handle, seek_zeil_basis + 3 * x_pos, SEEK_SET);
                    fread(&rgb_trip, 1, sizeof(rgb_trip), d_handle);
                    break;
                  }
                  case 8 : {
                    if(x_pos > ++alt_x) // berspringen von Pixeln
                      fseek(d_handle, seek_zeil_basis + x_pos, SEEK_SET);
                    fread(&f_wert, 1, sizeof(f_wert), d_handle);
                    break;
                  }
                  case 4 : {
                    {
                      register int seek_p = x_pos >> 1;
                      if(seek_p != alt_seek_p) {
                        if(seek_p > ++alt_seek_p)
                          fseek(d_handle, seek_zeil_basis + seek_p, SEEK_SET);
                        fread(&dat_byte, 1, sizeof(dat_byte), d_handle);
                        alt_seek_p = seek_p;
                      }
                    }
                    f_wert = (x_pos & 1 ? dat_byte &0xf : dat_byte >> 4);
                    break;
                  }
                  default : {
                    {
                      register int seek_p = x_pos >> 3;
                      if(seek_p != alt_seek_p) {
                        if(seek_p > ++alt_seek_p)
                          fseek(d_handle, seek_zeil_basis + seek_p, SEEK_SET);
                        fread(&dat_byte, 1, sizeof(dat_byte), d_handle);
                        alt_seek_p = seek_p;
                      }
                    }
                    f_wert = dat_byte >> (~x_pos & 0x7) & 0x1;
                    break;
                  }
                }
                alt_x = x_pos;
              }
              if(rgb_verarb) {
                if(konvert_ja) // Palettenfarbe zu RGB-Farbe umwandeln
                  zeichne_punkt (x, y, rgb_palette[f_wert][2],
                  rgb_palette[f_wert][1], rgb_palette[f_wert][0], dither);
                else
                  zeichne_punkt (x, y, rgb_trip[2], rgb_trip[1], rgb_trip[0],
                  dither);
              } else
                GrPlot(x, y, f_wert); // Farbe direkt setzen, da gengend
            }
          }
        }
      }
    } else {
      for(int y=0; no_fall_back && y < y_darst; y++) {
        fseek(d_handle, seek_start - seek_offs * y, SEEK_SET);
        for(int x=0; no_fall_back && x < x_darst; x++) {
          // Fallmssig unterscheiden anhand des Bildtyps
          switch(anz_bit_pro_pix) {
            case 24 : {
              fread(&rgb_trip, 1, sizeof(rgb_trip), d_handle);
              break;
            }
            case 8 : {
              fread(&f_wert, 1, sizeof(f_wert), d_handle);
              break;
            }
            case 4 : {
              if(x & 1)
                f_wert = dat_byte & 0xf;
              else {
                fread(&dat_byte, 1, sizeof(dat_byte), d_handle);
                f_wert = dat_byte >> 4;
              }
              break;
            }
            default : {
              if(!(x & 7))
                fread(&dat_byte, 1, sizeof(dat_byte), d_handle);
              f_wert = dat_byte >> (~x & 0x7) & 1;
            }
          }
          if(rgb_verarb) {
            if(konvert_ja) // Palettenfarbe zu RGB-Farbe umwandeln
              zeichne_punkt (x, y, rgb_palette[f_wert][2],
              rgb_palette[f_wert][1], rgb_palette[f_wert][0], dither);
            else
              zeichne_punkt (x, y, rgb_trip[2], rgb_trip[1], rgb_trip[0],
              dither);
          } else
            GrPlot(x, y, f_wert); // Farbe direkt setzen, da gengend
            // Palettenregister
        }
      }
    }
    anz_stufen = anz_st_m1;  // FallBack-Reduktion
  } while(!no_fall_back);
  fclose(d_handle);

  // Bild auf Wunsch abspeichern
  if(bild_abspeich_name[0]) {
    haenge_bmp_an(bild_abspeich_name); // Endung .BMP anhngen
    erfolg = speichere_als_bmp(bild_abspeich_name); // Bildschirminhalt
    // als neue Datei (oder alte berschreiben) abspeichern
  }
  
  // Warten auf Tastendruck
  getch();

  // Videmodus zurcksetzen
  GrSetMode(alter_videomodus);

  return 0;
}

void main() {
  char d_name[70];  // Dateiname des Bildes zu Anzeigen

  int fehler_code,  // Fehler-Rckgabecode des Bildladers
      einpass_ja,   // Flag fr automatische Einpassung (2)/Verzerrung (1)
      dither_ja,    // Flag, ob Dither- oder Volltondarstellung
      opt_nr,       // Nummer fr eingegebene Option
      a_stufen = max_anz_stufen; // Anzahl vom Benutzer gewhlte Farbstufen
                    // beim Startversuch

  // Initialisierung
  baue_dither_tabelle_auf();

  printf("\e[2J]\e[2;1HBildanzeigeprogramm fr Microsoft Windows(R)-"
  "Bitmapdateien\n");
  printf("Version 1.0 fr unkomprimierte Dateien\n");
  printf("(c) 1996 by Andreas Meile, HTL Brugg-Windisch\n\n");

  printf("Sie knnen sich die Auflsung selber aussuchen!\n\n");

  printf("Wichtiger Hinweis: ltere Grafiktreiber knnen Sie nur ber die\n"
  "Treiberkonstante ansteuern, ndern Sie diese daher nur ab, falls auf\n"
  "Ihrem System die Direkt-Videomoduswahl nicht korrekt luft.\n\n");
  lies_interv_ganze_zahl("Grafiktreiberkonstante Ihres Systems", "/",
  GR_320_200_graphics, GR_width_height_color_graphics, &treiber_konst);
  
  lies_positive_zahl("Horizontale Auflsung", "/", &x_aufl);
  lies_positive_zahl("Vertikale Auflsung", "/", &y_aufl);
  lies_positive_zahl("Anzahl Farben", "/", &a_far);

  // Anfrage, ob mit Vollton oder Dither
  if(a_far < 0x1000000) {
    do {
      printf("Vollton oder Ditherdarstellung (V/D) <D>? ");
      gets(d_name);
      opt_nr = werte_optionen_aus(d_name, "/V/v/D/d/");
      if(opt_nr == -1) {
        printf("Nur Eingabe V, v, D, d oder Leereingabe zulssig!\n");
      }
    } while(opt_nr == -1);
    dither_ja = (opt_nr >= 2);
  } else
    dither_ja = 1;

  // Anfrage fr die Zahl der Farbstufen, falls keine Echtfarbauflsung
  if(a_far < 32768) {
    lies_interv_ganze_zahl("Anzahl Farbstufen fr Start", "/", 2,
    max_anz_stufen, &a_stufen);
  }

  do {
    printf("Bild einpassen (V=verzerrt, d.h. fllend, J=prop.-treu) (J/N/V) <J>? ");
    gets(d_name);
    opt_nr=werte_optionen_aus(d_name, "/N/n/V/v/J/j/");
    if(opt_nr == -1) {
      printf("Nur Eingabe J, j, N, n, V, v oder Leereingabe zulssig!\n");
    }
  } while(opt_nr == -1);
  einpass_ja = (opt_nr >= 2) + (opt_nr >= 4); // 0=keine, 1=Verzerrt, 2=Prop.

  printf("\nName der anzuzeigenden Datei (ohne .BMP!)? ");
  gets(d_name);
  haenge_bmp_an(d_name); // Endung .BMP anhngen

  // Benutzer fragen, ob speichern am Schluss
  printf("\nEs besteht die Mglichkeit, das angezeigte Bild unter einem\n"
  "wahlweise anderen Namen zu speichern, auf diese Weise lsst sich dieser\n" 
  "Bildbetrachter als sehr einfaches Bitmapdateien-Verarbeitungswerkzeug\n"
  "einsetzen, mit welchem die Farben reduziert/erweitert sowie Skalierungen\n"
  "und Verzerrungen durchgefhrt werden knnen. Falls Sie keine Speicherung\n" 
  "wnschen, einfach <RETURN> alleine drcken\n");
  printf("\nDateiname fr Speicherung (ohne .BMP!) oder Leereingabe : ");
  gets(bild_abspeich_name);

  // Bild laden und anzeigen
  fehler_code = lade_bild(d_name, einpass_ja, dither_ja, a_stufen);

  printf("\e[2J\e[2;1H");
  switch(fehler_code) {
    case 0 : { // Erfolg
      printf("Dieses Bild wurde in der Auflsung %dx%d Bildpunkte sowie\n",
      x_aufl, y_aufl);
      printf("mit %d Farben gezeigt\n", a_far);
      printf("\nDaten zum Bild %s\n", d_name);
      printf("Grsse: %dx%d Bildpunkte, %d Farben\n", x_bild, y_bild,
      a_fa_bild);
      printf("Horizontale Punktdichte: %.4f dpi\n", ((float)(127 * x_dpm)) /
      5000.0);
      printf("Vertikale Punktdichte: %.4f dpi\n", ((float)(127 * y_dpm)) /
      5000.0);
      printf("\nGewhlte Darstelltechnik: ");
      if(rgb_verarb) {
        if(a_far >= 32768)
          printf("rasterfreie Echtfarb-Darstellung\n\n");
        else {
          printf("Dither-Technik mit optimierter Palette\n");
          anz_stufen++;
          printf("Es waren insgesamt %d FallBacks ntig, sodass insgesamt\n",
          a_stufen - anz_stufen);
          int a_stufen3 = anz_stufen * anz_stufen * anz_stufen;
          printf("%d Farbstufen pro Farbanteil resultieren (%d Basisfarben\n",
          anz_stufen, a_stufen3);
          printf("im RGB-Wrfel insgesamt)\n");
          printf("Farbspektumbeanspruchung im RGB-Wrfel : %d/%d = %.3f%%\n",
          anz_pal_far, a_stufen3, ((float)(100 * anz_pal_far)) /
          ((float)a_stufen3));
          printf("Ausnutzung der Bildschirmfarbpalette : %d/%d = %.3f%%\n\n",
          anz_pal_far, a_far, ((float)(100 * anz_pal_far)) / ((float)a_far));
        }
      } else
        printf("Direkt-Farbdarstellung (rasterfrei)\n\n");
      if(bild_abspeich_name[0])
        switch(erfolg) {
          case 0 : {
            printf("Bild erfolgreich unter %s neu abgespeichert\n",
            bild_abspeich_name);
            break;
          }
          case 1 : {
            printf("Fehler whrend des Abspeicherns unter %s\n",
            bild_abspeich_name);
            printf("Bild unvollstndig gespeichert\n");
            break;
          }
          case 2 : {
            printf("Fehler beim Anlegen der Datei %s\n", bild_abspeich_name);
            printf("(mglicherweise Fehler im Pfad) => nichts gespeichert\n");
            break;
          }
          default : {
            printf("Ein interner Fehler ist aufgetreten. Fehlercode: %d\n",
            erfolg);
          }
        }
      else
        printf("Neuabspeicherung wurde nicht erwnscht\n");
      break;
    }
    case 1 : { // Komprimiertes Bild, das momentan noch nicht untersttzt wird
      printf("Die angegebene Bilddatei ist komprimiert, was in dieser\n");
      printf("Version noch nicht untersttzt wird\n");
      break;
    }
    case 2 : { // Unbekannte Windows-Version
      printf("Datei mglicherweise von einer zuknftigen Windows-Version\n");
      break;
    }
    case 3 : { // Kein richtiges .BMP-File
      printf("Angegebene Datei beinhaltet keine Grafik\n");
      break;
    }
    case 4 : { // Datei berhaupt nicht vorhanden
      printf("Angegebene Datei konnte nicht geffnet werden\n");
      break;
    }
    default : { // sollte nicht auftreten!
      printf("Ein interner Fehler ist aufgetreten : %d\n", fehler_code);
    }
  }
}
